"""
Identifier:     mci_sim/tests/test_mci_sim.py
Name:           test_mci_sim.py
Description:    Test mci sim.
Author:         Zhaojun Yan
Created:        2024-04-09
Modified-History:
    2024-04-09, Zhaojun Yan, created

"""

import unittest
import os
import sys
import faulthandler
from csst_mci_sim import csst_mci_sim


class TestDemoFunction(unittest.TestCase):
    def test_mci_sim_1(self):
        """
        Aim
        ---
        Test mci sim function: EXDF case.

        Criteria
        --------
        Pass if the demo function returns `1`.

        Details
        -------
        The demo function returns the length of the input argument list.
        This case aims to test whether the demo function returns `1` if input is `None`.
        """
        faulthandler.enable()

        # demo function test
        dir_path = os.path.join(os.environ['UNIT_TEST_DATA_ROOT'], 'mci_sim/')
        print(dir_path)

        # 获取当前工作目录
        # current_path = os.getcwd()
        # print("当前路径:", current_path)

        configfile = './csst_mci_sim/mci_data/mci_C10.config'

        sourcein = 'EXDF'
        print(configfile)

        debug = True

        result_path = dir_path + 'mci_sim_result/'

        csst_mci_sim.runMCIsim(sourcein,  configfile,
                               dir_path, result_path, debug, 1)

        self.assertEqual(
            1, 1,
            "case 1: EXDF sim passes.",
        )
    ############################################

    def test_mci_sim_2(self):
        """
        Aim
        ---
        Test mci sim function: STAR case.

        Criteria
        --------
        Pass if the demo function returns `1`.

        Details
        -------
        The demo function returns the length of the input argument list.
        This case aims to test whether the demo function returns `1` if input is `None`.
        """
        faulthandler.enable()

        # demo function test
        dir_path = os.path.join(os.environ['UNIT_TEST_DATA_ROOT'], 'mci_sim/')
        print(dir_path)

        # 获取当前工作目录
        # current_path = os.getcwd()
        # print("当前路径:", current_path)

        configfile = './csst_mci_sim/mci_data/mci_C10.config'

        sourcein = 'STAR'
        print(configfile)

        debug = True

        result_path = dir_path + 'mci_sim_result/'

        csst_mci_sim.runMCIsim(sourcein,  configfile,
                               dir_path, result_path, debug, 1)

        self.assertEqual(
            1, 1,
            "case 2: STAR sim passes.",
        )

    #########################################################
    def test_mci_sim_3(self):
        """
        Aim
        ---
        Test mci sim function: BIAS case.

        Criteria
        --------
        Pass if the demo function returns `1`.

        Details
        -------
        The demo function returns the length of the input argument list.
        This case aims to test whether the demo function returns `1` if input is `None`.
        """
        faulthandler.enable()

        # demo function test
        dir_path = os.path.join(os.environ['UNIT_TEST_DATA_ROOT'], 'mci_sim/')
        print(dir_path)

        # 获取当前工作目录
        # current_path = os.getcwd()
        # print("当前路径:", current_path)

        configfile = './csst_mci_sim/mci_data/mci_C10.config'

        sourcein = 'BIAS'
        print(configfile)

        debug = True

        result_path = dir_path + 'mci_sim_result/'

        csst_mci_sim.runMCIsim(sourcein,  configfile,
                               dir_path, result_path, debug, 1)

        self.assertEqual(
            1, 1,
            "case 3: BIAS sim passes.",
        )
    #########################################################

    def test_mci_sim_4(self):
        """
        Aim
        ---
        Test mci sim function: DARK case.

        Criteria
        --------
        Pass if the demo function returns `1`.

        Details
        -------
        The demo function returns the length of the input argument list.
        This case aims to test whether the demo function returns `1` if input is `None`.
        """
        faulthandler.enable()

        # demo function test
        dir_path = os.path.join(os.environ['UNIT_TEST_DATA_ROOT'], 'mci_sim/')
        print(dir_path)

        # 获取当前工作目录
        # current_path = os.getcwd()
        # print("当前路径:", current_path)

        configfile = './csst_mci_sim/mci_data/mci_C10.config'

        sourcein = 'DARK'
        print(configfile)

        debug = True

        result_path = dir_path + 'mci_sim_result/'

        csst_mci_sim.runMCIsim(sourcein,  configfile,
                               dir_path, result_path, debug, 1)

        self.assertEqual(
            1, 1,
            "case 4: DARK sim passes.",
        )

    #########################################################
    def test_mci_sim_5(self):
        """
        Aim
        ---
        Test mci sim function: FLAT case.

        Criteria
        --------
        Pass if the demo function returns `1`.

        Details
        -------
        The demo function returns the length of the input argument list.
        This case aims to test whether the demo function returns `1` if input is `None`.
        """
        faulthandler.enable()

        # demo function test
        dir_path = os.path.join(os.environ['UNIT_TEST_DATA_ROOT'], 'mci_sim/')
        print(dir_path)

        # 获取当前工作目录
        # current_path = os.getcwd()
        # print("当前路径:", current_path)

        configfile = './csst_mci_sim/mci_data/mci_C10.config'
        sourcein = 'FLAT'
        print(configfile)

        debug = True

        result_path = dir_path + 'mci_sim_result/'

        csst_mci_sim.runMCIsim(sourcein,  configfile,
                               dir_path, result_path, debug, 1)

        self.assertEqual(
            1, 1,
            "case 5: FLAT sim passes.",
        )


# ############################################################################
